#ifndef __FILL_H_
#define __FILL_H_

/*  Fill functions, (C) Stepan Vartanov, 1993.
    This file contains fill function for BGI library, BC++ 3.x.
    The area may be represented as two-dimentional vessel, which
    we fill with water, in the absence of athmosphere.
*/

#include "graphpp.h"
#include "patterns.h"

#define MAX_SCREEN 640
enum FILL_STYLE { PATTERN_FILL, RANDOM_FILL };

struct FillArea
    {
    rect level[MAX_SCREEN];   // there are <= 640 elements in this realization,
		       // the VGA horiz. dimention. Using left-to-right fill
		       // we may use 480 elements
    char flag;         // draw_line (1) or go_local (0)
    int used;          // number of elements in level[]
    int local;         // is it local min ?
    rect work;         // used to avoid copying
    rect bound;        // outline of the area to fill, used to avoid copying
    int start_color;   // color in the start pixel, used to avoid copying

    int attr, bak;     // colors, used to avoid additional copying in put_pixel()
		       // calls
    int fill_style;    // PATTERN or RANDOM
    int pat;           // if one of PATTERNS.CPP

    FillArea() { fill_style = PATTERN_FILL; attr = WHITE; bak = BLACK;
	pat = 0; }

    protected:
	void put_pixel(int x, int y);
	int get_pixel(loc p);
	int get_pixel(int x, int y);
	int inside(loc p);
	int go_local(int left = 1);
	rect get_line();
	void remove(rect r);
	void add(rect r);
	void draw_line();
	void dump_levels();
	void fill_cell();
    public:
	void fill_area(loc from, rect r = rect(0, 0, getmaxx(), getmaxy()));
	int interrupted();
    };

#endif __FILL_H_